=== debian/changelog ===
prometheus-cpp (1.0.1-1) unstable; urgency=medium

  * Import latest 1.0.0 upstream release
  * Bump standards to version 4.6.1 (no changes needed)
  * Update Debian copyright file

 -- Gregor Jasny <gjasny@googlemail.com>  Sun, 22 May 2022 12:54:27 +0200

prometheus-cpp (1.0.0-1) unstable; urgency=medium

  * Initial release (Closes: #917817)

 -- Gregor Jasny <gjasny@googlemail.com>  Fri, 31 Dec 2021 12:36:31 +0100
