## prometheus-cpp 1.0.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 endif()
 
 project(prometheus-cpp
-  VERSION 1.0.1
+  VERSION 1.0.2
   DESCRIPTION "Prometheus Client Library for Modern C++"
   HOMEPAGE_URL "https://github.com/jupp0r/prometheus-cpp"
 )
