=== debian/changelog ===
prometheus-cpp (1.0.2-3) unstable; urgency=medium

  * fix: googletest 1.17.0 requires C++17 (Closes: #1113423)

 -- Gregor Jasny <gjasny@googlemail.com>  Tue, 02 Sep 2025 21:58:09 +0200

prometheus-cpp (1.0.2-2) unstable; urgency=medium

  * cleanup doygen output (Closes: #1048205)

 -- Gregor Jasny <gjasny@googlemail.com>  Wed, 16 Aug 2023 08:46:09 +0200

prometheus-cpp (1.0.2-1) unstable; urgency=medium

  * Import latest 1.0.x upstream release

 -- Gregor Jasny <gjasny@googlemail.com>  Mon, 07 Aug 2023 09:19:23 +0200

prometheus-cpp (1.0.1-2) unstable; urgency=high

  * Build Google Test with C++14 (Closes: #1041131)
  * Bumped standards to version 4.6.2 (no changes needed)

 -- Gregor Jasny <gjasny@googlemail.com>  Sun, 06 Aug 2023 17:58:22 +0200
