=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
                libcurl4-openssl-dev,
                ninja-build,
                zlib1g-dev
-Standards-Version: 4.6.1.0
+Standards-Version: 4.7.2
 Section: libs
 Homepage: https://github.com/jupp0r/prometheus-cpp
 Vcs-Browser: https://salsa.debian.org/debian/prometheus-cpp
