=== debian/tests/control ===
Tests: compile-examples
Depends: cmake, g++, prometheus-cpp-dev
