=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%prometheus-cpp-$1.tar.gz%" \
   https://github.com/jupp0r/prometheus-cpp/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
